<?php

class WDD_replace extends plxPlugin {

	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# limite l'accès à l'écran d'administration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		# Déclaration d'un hook (existant ou nouveau)
		$this->addHook('WDD_replace_start', 'WDD_replace_start');
		$this->addHook('WDD_replace_end', 'WDD_replace_end');
		$this->addHook('WDD_replace_list', 'WDD_replace_list');
		$this->addHook('ThemeEndBody', 'ThemeEndBody');
		
	}
	
	# HOOKS
	#
	# "WDD_replace_start"
	# Démarre la tamporisation 
	# (marque le début de la zone dans laquelle les règles de remplacement seront appliquées)
	public function WDD_replace_start($params) {echo '<?php ob_start(); ?>';}

	#
	# "WDD_replace_end"
	# Récupère le tampon et applique les remplacements prévus 
	# dans le fichier rules.php
	public function WDD_replace_end($params) { 
		echo '<?php $contenu = ob_get_clean();?>';
			echo str_replace('#PLUGINPATH#',PLX_PLUGINS.'WDD_replace/',file_get_contents(PLX_PLUGINS.'WDD_replace/rules.php'));		
			echo '<?php if (!function_exists("auto_thumb")){include("'.PLX_PLUGINS.'WDD_replace/auto_thumb.php");} ?>';		
			echo '<?php 
					$contenu= str_replace(array_keys($rule),array_values($rule),$contenu);
					if (preg_match_all(\'#(<galerie .*?>)#\', $contenu, $galeries)){
						// parse les commandes des galeries et récupère src et attr
						foreach ($galeries[1] as $galerie){
							// extraction des attr
							preg_match(\'#src="([^"]+)"#\',$galerie,$attr);
							$src=$attr[1];
							if (preg_match(\'#title="([^\"]+)"#\',$galerie,$attr)){$title=$attr[1];}else{$title=null;}
							if (preg_match(\'#width="([0-9]+)"#\',$galerie,$attr)){$width=$attr[1];}else{$width=null;}
							if (preg_match(\'#height="([0-9]+)"#\',$galerie,$attr)){$height=$attr[1];}else{$height=null;}
							if (stripos($galerie,"crop=")!==false){$crop=true;}else{$crop=false;}
							if (stripos($galerie,"infos=")!==false){$infos=true;}else{$infos=false;}
							if (stripos($galerie,"style=")!==false){$style=true;}else{$style=false;}
							//création du code de la galerie 
							$code=auto_galerie($src,$title,$width,$height,$crop,$infos,$style);
							$contenu=str_replace($galerie,$code,$contenu);
						}

					}';

			if (!empty($params)){ //changer images et liens ?
				echo '	
				$contenu= preg_replace(\'#(?<!["\\\'])(https?://.+(?:\.png|\.jpg|\.jpeg|\.gif))#i\',\'<img class="dans_commentaires" src="$1"/>\',$contenu);
				//$contenu= preg_replace(\'#(?<!["\\\'])((https?|ftp|file)://([-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|]))#i\',\'<a href="$1"/>$3</a>\',$contenu);
				//$contenu = preg_replace(\'#(?<!["\\\'])(((f|ht){1}tp://)[-a-zA-Z0-9@:%_+.~#?&//=]+)#i\',\'<a href="$1">$1</a>\', $contenu); 
				';
			}
			echo 'echo $contenu;?>';
		
	}

	#
	# "WDD_replace_list"
	# affiche ou renvoie la liste des règles ou la liste des remplacements
	# $param='list' => echo la liste des clés de $rule séparées par un espace
	# $param='emotes' => echo les émoticones de remplacement
	# $param='active_emotes' => echo les émoticones de remplacement avec leur attribut add (pour la fonction js d'ajout par clic)
	public function WDD_replace_list($param){// active_emotes, emotes, list

		echo str_replace('#PLUGINPATH#',PLX_PLUGINS.'WDD_replace/',file_get_contents(PLX_PLUGINS.'WDD_replace/rules.php'));		
		echo '<?php 
		$r="\n";$e="";$done="[spoiler] [/spoiler] ";
		foreach($rule as $rul=>$repl){';
			
			if ($param=="list"){ 
				echo 'echo $rul." ";';
			}else if ($param=="emotes"){
				echo 'if (!strpos($done,$repl)){echo $repl.$r;$done.=$repl." ";}';
			}else if ($param=="active_emotes"){
				echo 'if (!strpos($done,$repl)){echo str_replace("img ","img add=\"".$rul."\" ",$repl).$r;$done.=$repl." ";}';
			}
			echo '

		}
		echo $r."<br/>&#91;spoiler]...&#91;/spoiler]";
		?>';
	}

	public function ThemeEndBody() {
				//Si les smileys sont définis, on ajoute le javascript afin de les rendres cliquables sous le formulaire
				echo '
				<script type="text/javascript">/* <![CDATA[ */if(typeof(jQuery) === "undefined") document.write(\'<script  type="text/javascript" src="'.PLX_PLUGINS.'WDD_replace/jquery.min.js"><\/script>\');/* !]]> */</script>
				<script language="javascript">
				/* <![CDATA[ */
					// FONCTIONS	
				    function smiley(tag) {
				    	var myField;
				    	var myCommentTextarea = "id_content";
				    	tag = " " + tag + " ";
				    	if (tag == " spoiler ") {
				    		tag = "["+"spoiler][/spoiler"+"]";
				    	}
				        if (document.getElementById(myCommentTextarea) && document.getElementById(myCommentTextarea).type == \'textarea\') {
				    		myField = document.getElementById(myCommentTextarea);
				    	} else {
				    		return false;
				    	}
				    	if (document.selection) {
				    		myField.focus();
				    		sel = document.selection.createRange();
				    		sel.text = tag;
				    		myField.focus();
				    	} else if (myField.selectionStart || myField.selectionStart == \'0\') {
				    		var startPos = myField.selectionStart;
				    		var endPos = myField.selectionEnd;
				    		var cursorPos = endPos;
				    		myField.value = myField.value.substring(0, startPos)
				    					  + tag
				    					  + myField.value.substring(endPos, myField.value.length);
				    		cursorPos += tag.length;
				    		myField.focus();
				    		myField.selectionStart = cursorPos;
				    		myField.selectionEnd = cursorPos;
				    	} else {
				    		myField.value += tag;
				    		myField.focus();
				    	}
				    }
					// ACTIONS
					$(\'document\').ready(function(){
						// spoiler
						$(\'.spoiler\').click(function(){$(\'.cache\').toggle();return false;});

						// Ajout d\'un smiley par un clic
						$(\'.list_emotes img\').click(function(){tag=$(this).attr(\'add\');smiley(tag);});
						$(\'.list_emotes .addspoiler\').click(function(){tag=$(this).attr(\'add\');smiley(tag);});
					});
				/* !]]> */
				</script>
				';
			
		}
}
?>
